; a small tutorial(i just explain the basic steps, if you dont understand any word just ignore it
; and keep playing cs :P)
; half-life engine is represented by hw.dll, so this i the file we need to patch since it causes
; the "bug" we want to fix. fire up w32dasm or ida(i used ida since w32dsm crashed short before
; finishing the disasm). if you're under w32dasm look in the string refs for "unknown consistency
; type", in ida just push alt-t and enter the same text. you will land at rva 1000FDC, in ida it
; looks like this:
; 1000FDC3                 push    offset aUnknownConsist ; "Unknown consistency type %i\n"
; 1000FDC8                 call    loc_1003E310
; now just scroll up to the following:
; 1000FCE0                 jle     loc_1000FDBF
; 1000FCE6                 cmp     eax, 2
; 1000FCE9                 jg      loc_1000FDBF
; this is where the actual checks takes place, we simply need to nop out the two jumps, thats it :)

;*************************************************************************************************
;********************************************* OPTIONS *******************************************
;*************************************************************************************************
.386
.model flat, stdcall
option	casemap:none
;------------------------------------------[ Includes ]-------------------------------------------
include		windows.inc
include		kernel32.inc
include		user32.inc
include		comdlg32.inc
include		advapi32.inc
;------------------------------------------[ Libraries ]------------------------------------------
includelib	kernel32.lib
includelib	user32.lib
includelib	gdi32.lib
includelib  comdlg32.lib
includelib	advapi32.lib

WndProc	PROTO :HWND, :UINT, :WPARAM, :LPARAM

;*************************************************************************************************
;******************************************** VARIABLES ******************************************
;*************************************************************************************************
;------------------------------------------[ Constants ]------------------------------------------
.const

;------------------------------------[ Initialized Variables ]------------------------------------
.data
StartupInfo		STARTUPINFO {SIZEOF STARTUPINFO,NULL,NULL,NULL,0,0,0,0,0,0,0,STARTF_USESHOWWINDOW,SW_SHOWDEFAULT,0,NULL,0,0,0}

TargetExe		db "hl.exe",0							;Dateiname des Programs
TargetExe2		db "cstrike.exe",0
FileFilter		db "Half-Life (hl.exe)",0,"*.exe",0,0	;Filter

bytes			db 90h,90h,90h,90h,90h,90h

mh				db "hw.dll",0

err_topic		db "Error",0
err_text		db "Half-Life could not be found(hl.exe or cstrike.exe)!",0

tempFileName	db 360 dup(0)

bla				dd 0

;-----------------------------------[ Uninitialized Variables ]-----------------------------------
.data?
ThreadId		dd ?
hInstance		dd ?
temp			dd ?

ProcessInfo		PROCESS_INFORMATION <?>
ProcContext		CONTEXT <?>
ProcessAttributes SECURITY_ATTRIBUTES <?>
ThreadAttributes SECURITY_ATTRIBUTES <?>
ofstruct		OPENFILENAMEA <?>
me				MODULEENTRY32	<?>

;*************************************************************************************************
;*********************************************** CODE ********************************************
;*************************************************************************************************
.code

lcase proc text:DWORD

    ; -----------------------------
    ; converts string to lower case
    ; invoke lcase,ADDR szString
    ; -----------------------------

    push esi
    push edi

    mov esi, text
    mov edi, text
    
    cld

  lcSt:
    lodsb
    cmp al, 0       ; exit on zero terminator
    je lcOut
    cmp al, "A"
    jl @F
    cmp al, "Z"
    jg @F
    add al, 32
  @@:
    stosb
    jmp lcSt

  lcOut:
    stosb

    pop edi
    pop esi

    ret

lcase endp


sp_thread:
	invoke	WaitForSingleObject, [ProcessInfo.hProcess], INFINITE	
	jmp		mp_end

start:
	invoke	GetModuleHandle, NULL
	mov		[hInstance], eax

;-------------------------------------------------------------------------------------------------
	
	invoke	GetCommandLine
	mov		ebx, eax
	invoke	CreateProcess, addr [TargetExe], ebx, NULL, NULL, FALSE, NULL, NULL, 
						   NULL, addr [StartupInfo], addr [ProcessInfo]
	test	eax, eax
	jnz		sp_begin

	invoke	CreateProcess, addr [TargetExe2], ebx, NULL, NULL, FALSE, NULL, NULL, 
						   NULL, addr [StartupInfo], addr [ProcessInfo]
	test	eax, eax
	jz		mp_err

;-------------------------------------------------------------------------------------------------

sp_begin:

	invoke	CreateThread, NULL, NULL, sp_thread, NULL, NULL, addr [temp]
	mov		[me.dwSize], SIZE MODULEENTRY32

sp_start:
	invoke	CreateToolhelp32Snapshot, TH32CS_SNAPMODULE, [ProcessInfo.dwProcessId]
	mov		ebx, eax

	invoke	Module32First, ebx, addr [me]
	test	eax, eax
	jz		sp_loop
	invoke	lcase, addr [me.szModule]
	invoke	lstrcmp, addr [me.szModule], addr [mh]
	test	eax, eax
	jz		sp_goon
	
sp_loop2:
	invoke	Module32Next, ebx, addr [me]
	test	eax, eax
	jz		sp_loop
	invoke	lcase, addr [me.szModule]
	invoke	lstrcmp, addr [me.szModule], addr [mh]
	test	eax, eax
	jz		sp_goon
	jmp		sp_loop2

sp_loop:
	invoke	GetLastError
	invoke	CloseHandle, ebx
	invoke	Sleep, 500d
	jmp		sp_start

sp_goon:
	mov		ebx, [me.hModule]
	add		ebx, 0FCE0h
	invoke	VirtualProtectEx, [ProcessInfo.hProcess], ebx, 6, PAGE_READWRITE, addr [temp]
 	invoke	WriteProcessMemory, [ProcessInfo.hProcess], ebx, addr [bytes], 6, addr [temp]
	add		ebx, 9
	invoke	VirtualProtectEx, [ProcessInfo.hProcess], ebx, 6, PAGE_READWRITE, addr [temp]
 	invoke	WriteProcessMemory, [ProcessInfo.hProcess], ebx, addr [bytes], 6, addr [temp]

mp_end:
	invoke	ExitProcess, NULL
	ret

mp_err:
	invoke	MessageBox, NULL, addr [err_text], addr [err_topic], MB_OK
	jmp		mp_end
end start